function b=ftaubu(epst,ul,xl,G,M)
% This function  calculate Fourier transform of eps*h(u) analytically.

b=zeros(1,2*M+1);
lul=length(ul);

for n=-M:M
    if n~=0
        for j=2:lul
            a2=(xl(j)-xl(j-1))/(ul(j)-ul(j-1));
            a3=G*(ul(j)-ul(j-1))-(xl(j)-xl(j-1));
            u1=ul(j-1);
            u2=ul(j);
            gamma = exp(-i*2*pi*n*u2)-exp(-i*2*pi*n*u1);
            a2prim = i*epst(j-1)*a2/2/pi;
            a3prim = i*epst(j-1)*a3/2/pi/(u2-u1);
            a=1/(u2-u1);
            if abs(n-a)<1e-12
                a = n;
            end
            if abs(n+a)<1e-12
                a = -n;
            end
            if n==a
%                 a
                b(n+M+1) = b(n+M+1) + epst(j-1)*a/2*a3*(exp(-i*2*pi*n*u1)/a + ... 
                    i*(exp(-i*4*pi*n*u2)-exp(-i*4*pi*n*u1))*exp(-i*2*pi*n*u1)/4/pi/n);
            end
            if n^2-a^2~=0
                b(n+M+1)=b(n+M+1)+a3prim*n*gamma/(n^2-a^2)+a2prim*gamma/n;
            end
            if n==-a
                b(n+M+1) = b(n+M+1) + epst(j-1)*a/2*a3*(exp(-i*2*pi*n*u1)/a + ... 
                    i*(exp(-i*4*pi*n*u2)-exp(-i*4*pi*n*u1))*exp(-i*2*pi*n*u1)/4/pi/n);
            end
            
        end
    else
        for j=2:lul
            a2=(xl(j)-xl(j-1))/(ul(j)-ul(j-1));
            b(n+M+1)=b(n+M+1)+a2*epst(j-1)*(ul(j)-ul(j-1));
        end
    end
end
